//
// Definition of HistoryWindow Classes
//
// this belongs to the 'Tower of Benoi' Project
// Copyright 1998-1999
//
// Written by: Marco Zinn
//

#ifndef	HISTORY_WINDOW_H
#define	HISTORY_WINDOW_H

#include <InterfaceKit.h>

// The HistoryWindow is currently a quite one-way window:
// It show the number if moves and the moves themselves since the last reset.
// That means it just counts and displays your moves (or the moves wbile auto-solving)
class HistoryWindow : public BWindow {
	public:
		HistoryWindow(BRect frame, const char* name);
		void AddMove(int FromTower, int ToTower, int DiscSize);
			// Adds a move to the list and increases the counter
		void Reset();
	private:
		void ShowMoveCounter(); // Updates the MoveCounter Display

		BStringView *MoveCounter;
		BStringView *InfoLine;
		BListView	*Moves;
		uint32		MoveCount;
		int32		LastEffectiveMove; // must be signed as it is initialized with -1
};
 
#endif /* HISTORY_WINDOW_H */ 